/*************************************************************
Generated for IBM Rational Tau 4.3.0.4.22613 at Thu Dec 01 08:27:55 PM CET 2011
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2011.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
#ifndef __torEventQueue_h__
#define __torEventQueue_h__ (1)

#include "torPlatform.h"

#include "torEvent.h"
#include <list>

namespace tor 
{
    class Dispatchable;

    namespace os 
    {
        class Time;
    }

    class TOR_EXT_DEF EventQueue 
    {
    public:
        EventQueue();
        virtual ~EventQueue();

        virtual void insert(Event *event);
        virtual bool remove(Event *event);        

        virtual Event *get();
        virtual Event *get(os::Time timeout);
        virtual bool empty() const;

    protected:        
        typedef std::list<Event *> List;
        List m_list;
    };

} // tor namespace

#endif  // __torEventQueue_h__

